# -*- coding: utf-8 -*-
"""
Created on Thu Jun 21 12:10:24 2018

@author: sprimpke
"""
import numpy as np
import pandas as pd
import math as mt
import matplotlib.pyplot as plt
import numba
#import cudatoolkit
import time
from scipy.io import loadmat  # this is the SciPy module that loads mat-files
#from scipy.stats.stats import pearsonr
from Script_MPAPP_spero import analyse_dataframe
from Script_MPAPP_spero import get_base_name

#@numba.jit
def caluclate_map(array,pos,wn,ref,refshape,ref_sum,ref_pearson,fstref_sum,fstref_pearson,deltaX,deltaY,refID,QC=False): #The main process for spectral correlation performance
    print('Data loaded: Preparing data (vectornormalization)') 
    big_ref=refshape
    mshape=array.shape
    array_pearson_un=np.float32(prepare_array(array))   #Data preapreation for vector normalization
    array_vec2=vec_norm_OPUS(array_pearson_un)          #Vector Normalization
    array_vec=np.copy(array_vec2)                       #preparing a copy of the array due to numpy data handling
    array_pearson=np.float32(prepare_array(array_vec))  #Data preapreation for pearson correöation
    array_sum=sumitup(array_pearson)

    big_data=np.ndarray(shape=(int(mshape[0]),int(big_ref[0])), dtype=float) #The data array containing all for r calculation

    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    print('Data prepared. Starting correlation calculation')

    for i in range(0,mshape[0],1): #Calculates the term above the bracket of the Pearson correlation
        faster=(Multi(array_pearson[i],ref_pearson))
        res=np.zeros(int(big_ref[0]), dtype=np.float32)
        gusum(faster,res)
        for j in range(1,big_ref[0],1):
            big_data[i,j]=res[j] 
    ref_sum=np.transpose(ref_sum)
    big_data_sqrt=square_root(np.copy(array_sum),np.copy(ref_sum)) #Caculation of the term below the bracket of the pearson correclation
        
    r_map=np.ndarray(shape=(int(deltaX),int(deltaY)), dtype=float)
    ID_map=np.ndarray(shape=(int(deltaX),int(deltaY)), dtype=int)
    
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    print('Calculation correlation factor r')
    if QC:
        j_map=np.ndarray(shape=(int(deltaX),int(deltaY)), dtype=float)
        for i in range(0,big_data.shape[0],1): #calculating the poistion
            y_raw=(i)/int(deltaX)
            y=mt.trunc(y_raw)
            dy=np.int64(deltaY)
            ny=np.int64(y)
            x_raw=(i)-dy*ny
            x=int(x_raw)
            max_R=0
            max_ID=0
            max_j=0
            for j in range (0,big_data.shape[1],1):
                if big_data_sqrt[i,j]!=0:
                    r=big_data[i,j]/big_data_sqrt[i,j] #Calculating r
                else:
                    r=0
                if r < 0.300:
                    r=0
                elif r > max_R: # Check for maximum value
                    max_R = r
                    max_ID = refID[j]
                    max_j=j
            r_map[x,y]=max_R
            ID_map[x,y]=max_ID
            j_map[x,y]=max_j
            #i_map[x,y]=i
    else:
        for i in range(0,big_data.shape[0],1):
            y_raw=(i)/int(deltaX)
            y=mt.trunc(y_raw)
            dy=np.int64(deltaY)
            ny=np.int64(y)
            x_raw=(i)-dy*ny
            x=int(x_raw)
            max_R=0
            max_ID=0;
            for j in range (1,big_data.shape[1],1):
                if big_data_sqrt[i,j]!=0:
                    r=big_data[i,j]/big_data_sqrt[i,j] #Calculating r
                else:
                    r=0
                if r < 0.300:
                    r=0
                elif r > max_R:  # Check for maximum value
                    max_R = r
                    max_ID = refID[j]
            r_map[x,y]=max_R
            ID_map[x,y]=max_ID
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    print('Analysis via II Done')
    #Second term of calculation using the 1.st derivative if the data
    fst_r_map=np.ndarray(shape=(int(deltaX),int(deltaY)), dtype=float)

    fst_ID_map=np.ndarray(shape=(int(deltaX),int(deltaY)), dtype=int)

    array_vec=np.copy(array_vec2)
    fstderivate_data = np.diff(array_vec,n=1) #delivers first derivative

    fstarray_pearson=np.float32(prepare_array(fstderivate_data))
    fstarray_sum=sumitup(fstarray_pearson)


    big_data_fst=np.ndarray(shape=(int(mshape[0]),int(big_ref[0])), dtype=float)
    print('Data prepared. Starting correlation calculation for 1st Derivative')

    print(time.strftime("%d.%m.%Y %H:%M:%S"))

    for i in range(0,mshape[0],1): #Caluclating the values for cacluation of r 
        faster=Multi(fstarray_pearson[i],fstref_pearson)
        res=np.zeros(int(big_ref[0]), dtype=np.float32)
        gusum(faster,res)

        for j in range(1,big_ref[0],1):
            big_data_fst[i,j]=res[j]
            
    fstref_sum=np.transpose(fstref_sum)
    big_data_fst_sqrt=square_root(fstarray_sum,fstref_sum)
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    print('Calculation correlation factor r of 1st Derivative')
    for i in range(1,big_data.shape[0],1):
        y_raw=(i)/int(deltaX)
        y=mt.trunc(y_raw)
        dy=np.int64(deltaY)
        ny=np.int64(y)
        x_raw=(i)-dy*ny
        x=int(x_raw)
        max_R=0
        max_ID=0;
        for j in range (0,big_data.shape[1],1):
            if big_data_fst_sqrt[i,j] !=0:
                r=big_data_fst[i,j]/big_data_fst_sqrt[i,j] # caculation of r
            else:
                 r=0
            if r < 0.300:
                r=0
            elif r > max_R: #Find max r
                max_R = r
                max_ID = refID[j]
        fst_r_map[x,y]=max_R
        fst_ID_map[x,y]=max_ID

    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    print('III Done')


    autoanalyse=np.ndarray(shape=(int(deltaX),int(deltaY),3),dtype=int) # Data preparation for autoanalysis

    if not QC: #Classical way
        for i in range(0, int(deltaX),1):
            for j in range(0, int(deltaY),1):
                if ID_map[i,j] == fst_ID_map[i,j]:
                    autoanalyse[i,j,1]=ID_map[i,j]
                    autoanalyse[i,j,0]=int(round((r_map[i,j]+fst_r_map[i,j])*1000,0))
                else:
                    autoanalyse[i,j,1]=0
                    autoanalyse[i,j,0]=0
    else: # With database ID
        print('To Autoanalyse QC')
        #hits=np.ndarray(shape=(3,int(wn.shape[0])), dtype=float)
        #for i in range (0,wn.shape[0],1):
            #hits[0,i]=wn[i]
            #hits[1,i]=0

        print(time.strftime("%d.%m.%Y %H:%M:%S"))
        for i in range(0, int(deltaX),1):
            for j in range(0, int(deltaY),1):

                if ID_map[i,j] != 0 and fst_ID_map[i,j]!=0:
                    if ID_map[i,j] == fst_ID_map[i,j]:
                        autoanalyse[i,j,2]=int(j_map[i,j])
                        autoanalyse[i,j,1]=ID_map[i,j]
                        autoanalyse[i,j,0]=int(round((r_map[i,j]+fst_r_map[i,j])*1000,0))
                    else:
                        autoanalyse[i,j,2]=0
                        autoanalyse[i,j,1]=0
                        autoanalyse[i,j,0]=0   
                else:
                    autoanalyse[i,j,2]=0
                    autoanalyse[i,j,1]=0
                    autoanalyse[i,j,0]=0
        print('Autoanalyse Done')
    return autoanalyse 

@numba.vectorize(['float32(float32, float32)'], target='parallel')#target='cuda')
def Subs(x,y):
    return x-y

@numba.vectorize(['float32(float32, float32)'], target='parallel')#target='cuda')
def Adds(x,y):
    return x+y

@numba.vectorize(['float32(float32, float32)'], target='parallel')#target='cuda')
def Multi(x,y):
    return x*y

@numba.vectorize(['float32(float32, float32, float32)'], target='parallel')#target='cuda')
def r_it(x,y,z):
    return x/mt.sqrt(y*z)

@numba.vectorize(['float32(float32, float32)'], target='parallel')#target='cuda')
def square_root(x,y):
    return mt.sqrt(x*y)

@numba.vectorize(['float32(float32, float32)'], target='parallel')#target='cuda')
def Devide(x,y):
    return x/y

@numba.guvectorize(['void(float32[:],float32[:])'], '(m)->()',  target='parallel')#target='cuda')
def gusum(x,res):
    for j in range(0,res.shape[0],1):    
        for i in range(1,x.shape[0],1):
            res[j] = res[j] + x[i]

@numba.guvectorize(['void(float32[:,:],float32[:])'], '(m,n)->(m)',  target='parallel')#target='cuda')
def vecsum(x,res):
    for i in range(0,res.shape[0],1):    
        for j in range(0,x.shape[1],1):
            res[i] = res[i] + x[i,j]*x[i,j]
            

@numba.guvectorize(['void(float32[:,:],float32[:],float32[:,:])'], '(m,n),(m)->(m,n)',  target='parallel')#target='cuda')
def gu_devide(x,y,res):
    for i in range(0,x.shape[0],1):
        n=mt.sqrt(y[i])
        for j in range(0,x.shape[1],1):
            res[i,j] = x[i,j]/n

#@numba.jit#(nopython = True, parallel = True)
def sumitup(array): #Delivers the sum ((x-xm)²) term
    array=Multi(array,array) #array = x-xm 
    length=array.shape # For data output
    d=np.ndarray(shape=(length[0],1),dtype=np.float32)
    d=np.float32(d)
    for i in range (0, length[0],1): #Delivers sum ((x-xm)²) 
        d[i]=sum(array[i])
    return d

#@numba.jit
def prepare_array(array): # Calculates the x-xm value for each datapoint
    length=array.shape
    for i in range (0, length[0],1):
        array[i]=array[i]-average(array[i])
    return array       

#@numba.jit(parallel = True, nogil = True)
def average(x):
    assert len(x) > 0
    return float(sum(x)) / len(x)

#@numba.jit(parallel = True, nogil = True) # for array_pearson
def vec_norm_OPUS(array):
    length=array.shape

    res=np.zeros(int(length[0]), dtype=np.float32)

    vecsum(array,res) 

    vec_spec=np.ndarray(shape=length, dtype=np.float32)
    gu_devide(array,res,vec_spec)
    print('Normalized')
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    return vec_spec


def ndarray2dataframe(array,x_max,y_max):
    #@numba.jit(parallel = True, nogil = True)
    def hyperhyper(array,x_max,y_max):
        arrays=np.zeros(shape=(1,5),dtype=int)
        darray=np.copy(arrays)
        hits=0
        for i in range (0,x_max,1):
            for j in range (0,y_max,1):
                if int(array[i,j,0])>0:
                    darray[0,0]=int(i)
                    darray[0,1]=int(j)
                    darray[0,2]=int(array[i,j,0])
                    darray[0,3]=int(array[i,j,1])
                    darray[0,4]=int(array[i,j,2])
                    hits+=1
                    arrays=np.append(arrays,darray,axis=0)
        print(hits)
        return arrays
    """Create image from data frame.
    
    data: data frame with columns x, y, g
    size: tuple of width and height
    
    image: size width x height image
    """
    print(array[:,:,0])
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    hyper=hyperhyper(array,x_max,y_max)
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    print(hyper.shape)
    dfimage=pd.DataFrame(hyper[:,:],index=hyper[:,0],columns=['x','y','g','p','DB'])
    dfimage.reset_index(drop=True,inplace=True)
    qc = pd.Series(np.zeros(len(dfimage)), index=dfimage.index, name='qc') # temporary
    dfimage_qc = pd.concat([dfimage, qc], axis=1)
    print(dfimage_qc)
    return dfimage_qc             

@numba.jit
def makeitcompatible(array,datapoints,start,ende): #Important for FTIR to matching datapoints in whole numbers
    length = array.shape
    x_Start=int(start)
    dd=array[0,0]-array[0,1]
    x_Ende=ende
    diff=x_Start-x_Ende+datapoints
    if (diff/datapoints)+1 == length[1]:
        newdata=np.ndarray(shape=(length[0]-1,int(diff/datapoints)), dtype=float)
    else:
        newdata=np.ndarray(shape=(length[0]-1,int(diff/datapoints)), dtype=float)
    length2=newdata.shape
    for i in range (1,length[0],1):
        n=0
        k=0
        while k <= length[1] and n < length2[1]:
            if x_Start-n*datapoints <= array[0,k+1]: # if the wavenumber difference (dd) is short as in the database this step is necessary
                k +=1
            else:
                newdata[i-1,n]=array[i,k]+(((array[i,k+1]-array[i,k])/dd)*((array[0,k]-(x_Start-n*datapoints)))) 
                n=n+1
    return newdata

def analyse_file(filename,deltaX,deltaY,x_max,y_max,res,Matlab=False,FTIR=False,QC=False,Matlabfilelist=False):
    print('Starting analysis')
    print(time.strftime("%d.%m.%Y %H:%M:%S"))
    exportname = get_base_name(filename)
    print(exportname)
    if Matlabfilelist and Matlab and not FTIR: #For Spero data of a file list
        namelist=pd.read_csv(filename, delimiter=';')
        print(namelist)
        
        for i in namelist.index:
            name=str(namelist.name[i])
            #print(name)
            mat = loadmat(name)

            wn_mat = mat['wn']  # Read out for x Labels
            
            deltaX = mat['dY']  # variable in mat file
            deltaY = mat['dX']  #
            print(wn_mat.shape)
            #mdata3 = mat['wn']  # Read out for x Labels
            mdata4  = mat['r']  ## Read out for data as 2D array
            #print(mdata4.shape)
            
            refdata=np.loadtxt('Database_Spero_automated.csv',dtype=float,delimiter=';')
            ref0=np.transpose(refdata)
            wn=np.copy(ref0[0,:])
            #print(wn)
            print(time.strftime("%d.%m.%Y %H:%M:%S"))                    
                    
            if wn_mat.shape[0]!=refdata.shape[0]: #This process harmonizes input data and reference to the same data points. Got necessary due to the gap if a Anodsic was used for the single data on BaF2 windowns
                a=0
                b=0
                reallength=1
                if wn_mat.shape[0]>refdata.shape[0]:     #Check which dataset is smaller            
                    for nope in range(0,wn_mat.shape[0],1):
                        if int(wn_mat[a]) == int(wn[b]): #Hit if both have the same value
                            reallength+=1
                            a+=1
                            b+=1
                        elif int(wn_mat[a]) > int(wn[b]): #Selected increase of the smaller number
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                else:
                    for nope in range(1,refdata.shape[0],1): 
                        if int(wn_mat[a]) == int(wn[b]):#Hit if both have the same value
                            reallength+=1
                            a+=1
                            b+=1
                        elif int(wn_mat[a]) > int(wn[b]):#Selected increase of the smaller number
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                #print(reallength)
                ref = np.ndarray(shape=(ref0.shape[0],reallength),dtype=np.float32) #Generation of harmonized data sets
                newdata = np.ndarray(shape=(mdata4.shape[0],reallength),dtype=np.float32)
                # print(ref.shape)
                a=0
                b=0
                c=0
                if wn_mat.shape[0]>refdata.shape[0]:
                    while a < (wn_mat.shape[0]) and b < reallength+1:
                        if int(wn_mat[a]) == int(wn[b]):
                            newdata[:,c] = mdata4[:,a]
                            ref[:,c] = ref0[:,b]
                            a+=1
                            b+=1
                            c+=1
                            #print(a,b)
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                else:
                    while b < (refdata.shape[0]) and a < reallength+1:
                        if int(wn_mat[a]) == int(wn[b]):
                            newdata[:,c] = mdata4[:,a]
                            ref[:,c] = ref0[:,b]
                            a+=1
                            b+=1
                            c+=1
                            #print(a,b)
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
            else: #But only if they differ
                ref=ref0
                newdata = mdata4

        
            refID=np.loadtxt('Database_Spero_automated_ID.csv',dtype=int,delimiter=';') #Preparation of the reference prior to data analysis to save calculation time
            refID=np.transpose(refID)
            refshape=ref.shape
        
            ref_pearson_un=np.float32(prepare_array(ref))
            ref_vec=vec_norm_OPUS(ref_pearson_un)  #Application of vector normallization
        
            ref_vec_copy=np.copy(ref_vec)
            ref_pearson=np.float32(prepare_array(ref_vec))
            ref_vec_raw=np.copy(ref_vec)
            ref_sum=sumitup(ref_pearson) # Data set ready for calculations of r
            fstderviate_ref = np.diff(ref_vec_raw,n=1) #Numcerical calculation of the first derivative of the data 
            fstref_pearson=np.float32(prepare_array(fstderviate_ref))
            fstref_sum=sumitup(fstref_pearson)# Data set ready for calculations of r
            print(time.strftime("%d.%m.%Y %H:%M:%S"))
            #np.savetxt('nervig.csv',mdata3,delimiter=';')
            #print(time.strftime("%d.%m.%Y %H:%M:%S"))
            mapping=caluclate_map(newdata,i,wn,ref_vec_copy,refshape,ref_sum,ref_pearson,fstref_sum,fstref_pearson,deltaX,deltaX,refID,QC=QC) #Delivering the data to the calculation function
        
            df=ndarray2dataframe(mapping,int(deltaX[0]),int(deltaY[0]))
            print(time.strftime("%d.%m.%Y %H:%M:%S"))
            name='for_siMPLe_final_full_lADD'+name+'.csv'
            df.to_csv(name, sep=';',index = False)
                
                
    if Matlab and not Matlabfilelist: #For the calculation of chemical maps from FTIR or SperoQT
        namelist=pd.read_csv(filename, delimiter=';')
        print('Reading in dataset')
        print(namelist)
        if FTIR:
            ref=np.loadtxt('ADD_database_4dp.csv',dtype=float,delimiter=';') #Loading of the reference database
            ref0=np.transpose(ref)
            wn=np.copy(ref0[0,:])
            ref=ref0
            #print(ref.shape)
            refID=np.loadtxt('ADD_cluster.csv',dtype=int,delimiter=';') #Loading of the polymer type IDs
            refID=np.transpose(refID)
            refshape=ref.shape
        else:
            refdata=np.loadtxt('Database_Spero_automated.csv',dtype=float,delimiter=';') #Loading of the reference database
            ref0=np.transpose(refdata)
            print(refdata.shape)
            print(ref0.shape)
            wn=np.copy(ref0[0,:])
            #ref=ref0
            #Checking for data equality
            name=str(namelist.name[1])
            print(name)
            mat = loadmat(name)
            wn_mat = mat['wn']  # Read out for x Labels

            if wn_mat.shape[0]!=refdata.shape[0]: #If the wavenumbers are different start a harmonization procedure
                a=0
                b=0
                reallength=1
                if wn_mat.shape[0]>refdata.shape[0]:     #Check which dataset is smaller                 
                    for nope in range(0,wn_mat.shape[0],1):
                        if int(wn_mat[a]) == int(wn[b]): #Hit if both have the same value
                            reallength+=1
                            a+=1
                            b+=1
                        elif int(wn_mat[a]) > int(wn[b]): #Selected increase of the smaller number 
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                else:
                    for nope in range(1,refdata.shape[0],1):
                        if int(wn_mat[a]) == int(wn[b]): #Hit if both have the same value
                            reallength+=1
                            a+=1
                            b+=1
                        elif int(wn_mat[a]) > int(wn[b]): #Selected increase of the smaller number 
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1

                ref = np.ndarray(shape=(ref0.shape[0],reallength),dtype=np.float32)

                a=0
                b=0
                c=0
                if wn_mat.shape[0]>refdata.shape[0]: #Converting the reference data similar to the map files
                    while a < (wn_mat.shape[0]) and b < reallength+1:
                        if int(wn_mat[a]) == int(wn[b]):
                            ref[:,c] = ref0[:,b]
                            a+=1
                            b+=1
                            c+=1
                            #print(a,b)
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                else:
                    while b < (refdata.shape[0]) and a < reallength+1:
                        if int(wn_mat[a]) == int(wn[b]):
                            ref[:,c] = ref0[:,b]
                            a+=1
                            b+=1
                            c+=1
                            #print(a,b)
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
            else: #If the same just rename
                ref=ref0
                
            refID=np.loadtxt('Database_Spero_automated_ID.csv',dtype=int,delimiter=';')
            refID=np.transpose(refID)

            refshape=ref.shape
         #Preparation of the reference prior to data analysis to save calculation time    
        ref_pearson_un=np.float32(prepare_array(ref))
        ref_vec=vec_norm_OPUS(ref_pearson_un) #Application of vector normallization     
        ref_vec_copy=np.copy(ref_vec)
        ref_pearson=np.float32(prepare_array(ref_vec))
        ref_vec_raw=np.copy(ref_vec)
        ref_sum=sumitup(ref_pearson) # Data set ready for calculations of r
        fstderviate_ref = np.diff(ref_vec_raw,n=1) #Numcerical calculation of the first derivative of the data 
        fstref_pearson=np.float32(prepare_array(fstderviate_ref))
        fstref_sum=sumitup(fstref_pearson) # Data set ready for calculations of r
        
        if FTIR:
            fullmap=np.ndarray(shape=(deltaX*x_max,deltaY*y_max,3),dtype=np.float32)
            print(time.strftime("%d.%m.%Y %H:%M:%S"))
            print('Start')
            for i in namelist.index:
                name=str(namelist.name[i])
                print(name)
                mat = loadmat(name)
                rawdata  = mat['AB']
                rawdata=np.transpose(rawdata)
                mdata4=makeitcompatible(rawdata,4,3592,1252) #FTIR data often has float values for x which need to be recalculated on whole number positions as these have an instrumental variation

                mapping=caluclate_map(mdata4,i,wn,ref_vec_copy,refshape,ref_sum,ref_pearson,fstref_sum,fstref_pearson,deltaX,deltaX,refID,QC=QC) #Delivering the data to the calculation function
                #Transfer data to autoanalysis format on the overall map
                pos=mt.trunc(i/x_max)

                py=int(pos*deltaY)
                px=int((i-pos*x_max)*deltaX)

                for j in range(0,int(deltaX),1):
                    for k in range(0,int(deltaY),1):
                        fullmap[px+k,py+j,0]=mapping[j,k,0]
                        fullmap[px+k,py+j,1]=mapping[j,k,1]
                        fullmap[px+j,py+k,2]=mapping[j,k,2]

        else:
            print(time.strftime("%d.%m.%Y %H:%M:%S"))
            print('Start')
            fullmap=np.ndarray(shape=(x_max*480,y_max*480,3),dtype=np.float32)
            for i in namelist.index:
                name=str(namelist.name[i])
                print(name)
                mat = loadmat(name)
                deltaX = mat['dY']  # variable in mat file
                deltaY = mat['dX']  #
                mdata4  = mat['r']  ## Read out for data as 2D array
                if wn_mat.shape[0]>refdata.shape[0]:  #Harmonize data to reference
                    newdata = np.ndarray(shape=(mdata4.shape[0],reallength),dtype=np.float32)
                    # print(ref.shape)
                    a=0
                    b=0
                    c=0
                    while a < (wn_mat.shape[0]) and b < reallength+1:
                        if int(wn_mat[a]) == int(wn[b]):
                            newdata[:,c] = mdata4[:,a]
                            a+=1
                            b+=1
                            c+=1
                            #print(a,b)
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                    mapping=caluclate_map(newdata,i,wn,ref_vec_copy,refshape,ref_sum,ref_pearson,fstref_sum,fstref_pearson,deltaX,deltaX,refID,QC=QC)  #Delivering the data to the calculation function
                else:
                    	#If necessary
                    mapping=caluclate_map(mdata4,i,wn,ref_vec_copy,refshape,ref_sum,ref_pearson,fstref_sum,fstref_pearson,deltaX,deltaX,refID,QC=QC) #Delivering the data to the calculation function
                #Transfer data to autoanalysis format on the overall map
                pos=mt.trunc(i/x_max)

                py=int(pos*deltaY[0])
                px=int((i-pos*x_max)*deltaX[0])

                for j in range(0,int(deltaX[0]),1):

                    for k in range(0,int(deltaY[0]),1):
                        fullmap[px+j,py+k,0]=mapping[j,k,0]
                        fullmap[px+j,py+k,1]=mapping[j,k,1]
                        fullmap[px+j,py+k,2]=mapping[j,k,2]

        print(time.strftime("%d.%m.%Y %H:%M:%S"))  
        print('Piece of cake')
    else:
        mdata4=np.loadtxt(filename,dtype=float,delimiter=';')
        
        ref=np.loadtxt('ADD_database_4dp.csv',dtype=float,delimiter=';')
        ref0=np.transpose(ref)
        wn=np.copy(ref0[0,:])
        ref=ref0
        ref_pearson_un=np.float32(prepare_array(ref))
        ref_vec=vec_norm_OPUS(ref_pearson_un)   
        ref_vec_copy=np.copy(ref_vec)
        ref_pearson=np.float32(prepare_array(ref_vec))
        ref_vec_raw=np.copy(ref_vec)
        ref_sum=sumitup(ref_pearson)
        fstderviate_ref = np.diff(ref_vec_raw,n=1)
        fstref_pearson=np.float32(prepare_array(fstderviate_ref))
        fstref_sum=sumitup(fstref_pearson)
        
        print(ref.shape)
        refID=np.loadtxt('ADD_cluster.csv',dtype=int,delimiter=';')
        refID=np.transpose(refID)
        i=0
        print(time.strftime("%d.%m.%Y %H:%M:%S"))
        fullmap=caluclate_map(mdata4,i,wn,ref_vec_copy,refshape,ref_sum,ref_pearson,fstref_sum,fstref_pearson,deltaX,deltaX,refID,QC=QC)
    if not Matlabfilelist:
        #Transfer to Image Analysis
        print('To Autoanalyse')
        if FTIR:
            df=ndarray2dataframe(fullmap,x_max*deltaX,y_max*deltaY)
            name='analyzed_'+exportname
            df.to_csv(name, sep=';',index = False)
            #name='image_analysis/'+name
            #analyse_dataframe(df,name,res) #Currently not compatible with FTIR data. Please use the APA.exe or MPAPP.exe from https://drive.google.com/drive/folders/1O3vtsb963KoGwsTTGvDZgo8KUqjGjNAD?usp=sharing
        else:
            df=ndarray2dataframe(fullmap,int(x_max*deltaX[0]),int(y_max*deltaY[0]))
            name='analyzed_'+exportname
            df.to_csv(name, sep=';',index = False)
            name='image_analysis/'+name
            analyse_dataframe(df,name,res)
            print(time.strftime("%d.%m.%Y %H:%M:%S"))
    return #df

def plotter(x,y,refdata,data_limiter='',save=False):
    y_o=y-min(y)
    ref_o=refdata-min(refdata)
    y_n=y_o/max(y_o)
    ref_n=ref_o/max(ref_o)
    plt.figure(dpi = 200)
    plt.ylabel('QCL signal')
    plt.xlabel('Wavenumber cm-1')
    plt.axis([1800,1084,-0.1,1])
    plt.plot(x,y_n)
    plt.plot(x,ref_n)
    plt.show()
    var = 0
    while var != '5' and var != '4'  and var != '3' and var != '2' and var != '1': # For manual reanalysis
        var = input("Rate quality (1=1,2=0.75,3=0.5,4=0.25,5=0.01) ")
    if var == '5':
        var = 0.01
    elif var =='4':
        var = 0.25
    elif var =='3':
        var = 0.50
    elif var =='2':
        var = 0.75
    elif var =='1':
        var = 1.00
    name=data_limiter+'_QF_'+str(var)
    plt.close()
    if save: #Figure output
        plt.figure()
        plt.ylabel('QCL signal')
        plt.xlabel('Wavenumber cm-1')
        plt.axis([1800,1084,-0.1,1])
        plt.plot(x,y_n)
        plt.plot(x,ref_n)
        plt.title(name)
        name='QCL_Images/'+str(data_limiter)+'_QF_'+str(var)+'.png'
        plt.savefig(name, dpi = 600)
        plt.close()       
    return float(var) #Hand back the result of the evaluation


def evaluate_file(qcfilename,reffilename,deltaX,deltaY,x_max,y_max,Matlab=False,SingleFile=False,FTIR=False): #Allows quality control of the genearted data
    if Matlab: #Reads in the data
        if not SingleFile:
            namelist=pd.read_csv(reffilename, delimiter=';')
        qclist=pd.read_csv(qcfilename, delimiter=';')
        #print(qclist)
        if FTIR: #Database determination and loading
            ref=np.loadtxt('ADD_database_4dp.csv',dtype=float,delimiter=';')
            ref0=np.transpose(ref)
            wn=np.copy(ref0[0,:])
            #print(ref.shape)
        elif not SingleFile:
            ref=np.loadtxt('Database_Spero_automated.csv',dtype=float,delimiter=';')
            ref0=np.transpose(ref)
            wn=np.copy(ref0[0,:])
              
        if FTIR: #Yet not implemented for FTIR
            pass
        elif not SingleFile:
            for idx in qclist.index: # For rach entry do
                if qclist.qc[idx] == 0:
                    xfield=mt.trunc(qclist.x[idx]/deltaX) #Get the correct file
                    yfield=mt.trunc(qclist.y[idx]/deltaY) #Get the correct file
                    fdx=xfield+yfield*x_max #Calculated its position in the namelist file        
                    name=str(namelist.name[fdx]) #Read in the file name
                    mat = loadmat(name)
                    wn_mat = mat['wn']
                    mdata4  = mat['r']  ## Read out for data as 2D array
                    refdata=np.loadtxt('Database_Spero_automated.csv',dtype=float,delimiter=';') #Load he reference
                    ref0=np.transpose(refdata)
                    wn=np.copy(ref0[0,:])

                    print(refdata.shape)
                    print(mdata4.shape)
                    if wn_mat.shape[0]!=refdata.shape[0]: #Data harmonization to similar wave numbers
                        a=0
                        b=0
                        reallength=1
                        if wn_mat.shape[0]>refdata.shape[0]:                
                            for nope in range(0,wn_mat.shape[0],1):
                                if int(wn_mat[a]) == int(wn[b]):
                                    reallength+=1
                                    a+=1
                                    b+=1
                                elif int(wn_mat[a]) > int(wn[b]):
                                    b+=1
                                elif int(wn_mat[a]) < int(wn[b]):
                                    a+=1
                        else:
                            for nope in range(1,refdata.shape[0],1):
                                if int(wn_mat[a]) == int(wn[b]):
                                    reallength+=1
                                    a+=1
                                    b+=1
                                elif int(wn_mat[a]) > int(wn[b]):
                                    b+=1
                                elif int(wn_mat[a]) < int(wn[b]):
                                    a+=1
                        ref = np.ndarray(shape=(ref0.shape[0],reallength),dtype=np.float32)
                        data = np.ndarray(shape=(mdata4.shape[0],reallength),dtype=np.float32)
                        new_wn = np.ndarray(shape=(reallength,1),dtype=np.float32)
                        a=0
                        b=0
                        c=0
                        if wn_mat.shape[0]>refdata.shape[0]:
                            while a < (wn_mat.shape[0]) and b < reallength+1:
                                if int(wn_mat[a]) == int(wn[b]):
                                    data[:,c] = mdata4[:,a]
                                    ref[:,c] = ref0[:,b]
                                    new_wn[c]= np.float32(wn[b])
                                    a+=1
                                    b+=1
                                    c+=1
                                elif int(wn_mat[a]) > int(wn[b]):
                                    b+=1
                                elif int(wn_mat[a]) < int(wn[b]):
                                    a+=1
                        else:
                            while b < (refdata.shape[0]) and a < reallength+1:
                                if int(wn_mat[a]) == int(wn[b]):
                                    data[:,c] = mdata4[:,a]
                                    ref[:,c] = ref0[:,b]
                                    new_wn[c]= np.float32(wn[b])
                                    a+=1
                                    b+=1
                                    c+=1
                                elif int(wn_mat[a]) > int(wn[b]):
                                    b+=1
                                elif int(wn_mat[a]) < int(wn[b]):
                                    a+=1
                    
                    
                    
                        midx=(qclist.x[idx]-xfield*deltaX)+(deltaX*(qclist.y[idx]-yfield*deltaY))
                        qclist.qc[idx] = plotter(new_wn,data[midx],ref0[qclist.DB[idx]])*100 #Perform data evaluation
                        print(qclist.qc[idx])
                        qclist.to_csv(qcfilename, sep=';',index = False)
                    
                    midx=(qclist.x[idx]-xfield*deltaX)+(deltaX*(qclist.y[idx]-yfield*deltaY)) #Get the position within the data array of the matlab file
                    print(midx)
                    qclist.qc[idx] = plotter(wn,mdata4[midx],ref0[qclist.DB[idx]],data_limiter=qcfilename+'_'+str(qclist.x[idx])+'_'+str(qclist.y[idx])+'_'+str(qclist.p[idx]),save=True)*100 #Perform data evaluation
                    print(qclist.qc[idx])
                    qclist.to_csv(qcfilename, sep=';',index = False)
                    
        else:
            mat = loadmat(reffilename)
            wn_mat = mat['wn']  # Read out for x Labels
            print(wn_mat.shape)
            mdata4  = mat['r']  ## Read out for data as 2D array
            refdata=np.loadtxt('Database_Spero_automated.csv',dtype=float,delimiter=';')
            ref0=np.transpose(refdata)
            wn=np.copy(ref0[0,:])

            print(refdata.shape)
            print(mdata4.shape)
            if wn_mat.shape[0]!=refdata.shape[0]: #Data harmonization to similar wave numbers
                a=0
                b=0
                reallength=1
                if wn_mat.shape[0]>refdata.shape[0]:                
                    for nope in range(0,wn_mat.shape[0],1):
                        if int(wn_mat[a]) == int(wn[b]):
                            reallength+=1
                            a+=1
                            b+=1
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                else:
                    for nope in range(1,refdata.shape[0],1):
                        if int(wn_mat[a]) == int(wn[b]):
                            reallength+=1
                            a+=1
                            b+=1
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                #print(reallength)
                ref = np.ndarray(shape=(ref0.shape[0],reallength),dtype=np.float32)
                data = np.ndarray(shape=(mdata4.shape[0],reallength),dtype=np.float32)
                new_wn = np.ndarray(shape=(reallength,1),dtype=np.float32)
                # print(ref.shape)
                a=0
                b=0
                c=0
                if wn_mat.shape[0]>refdata.shape[0]:
                    while a < (wn_mat.shape[0]) and b < reallength+1:
                        if int(wn_mat[a]) == int(wn[b]):
                            data[:,c] = mdata4[:,a]
                            ref[:,c] = ref0[:,b]
                            new_wn[c]= np.float32(wn[b])
                            a+=1
                            b+=1
                            c+=1
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                else:
                    while b < (refdata.shape[0]) and a < reallength+1:
                        if int(wn_mat[a]) == int(wn[b]):
                            data[:,c] = mdata4[:,a]
                            ref[:,c] = ref0[:,b]
                            new_wn[c]= np.float32(wn[b])
                            a+=1
                            b+=1
                            c+=1
                        elif int(wn_mat[a]) > int(wn[b]):
                            b+=1
                        elif int(wn_mat[a]) < int(wn[b]):
                            a+=1
                print(data.shape)
                print(mdata4.shape)
                print(ref.shape)
                
                print(time.strftime("%d.%m.%Y %H:%M:%S"))
                for idx in qclist.index:
                    if qclist.qc[idx] == 0:
                        xfield=mt.trunc(qclist.x[idx]/deltaX)
                        yfield=mt.trunc(qclist.y[idx]/deltaY)
                        fdx=xfield+yfield*x_max              
                        midx=qclist.x[idx]+(deltaX*qclist.y[idx])
                        qclist.qc[idx] = plotter(new_wn,data[midx],ref[qclist.DB[idx]],data_limiter=qcfilename+' '+str(qclist.p[idx]),save=True)*100 #Perform data evaluation
                        print(qclist.qc[idx])
                        qclist.to_csv(qcfilename, sep=';',index = False)
            
            else:
                ref=ref0
                print(time.strftime("%d.%m.%Y %H:%M:%S"))
                for idx in qclist.index:
                    if qclist.qc[idx] == 0:
                        xfield=mt.trunc(qclist.x[idx]/deltaX)
                        yfield=mt.trunc(qclist.y[idx]/deltaY)
                        fdx=xfield+yfield*x_max              
                        midx=qclist.x[idx]+(deltaX*qclist.y[idx])
                        print(qclist.DB[idx])
                        qclist.qc[idx] = plotter(wn_mat,mdata4[midx],ref[qclist.DB[idx]],data_limiter=qcfilename+' '+str(qclist.p[idx]),save=True)*100 #Perform data evaluation
                        print(qclist.qc[idx])
                        qclist.to_csv(qcfilename, sep=';',index = False)

            

    return #df

def TwoDplotter(matrix,name,wn,save=True): # Plots the maps
    plt.title(name)
    fig=plt.figure(figsize=(6, 3.2),dpi = 200)
    ax = fig.add_subplot(111)
    ax.set_title('colorMap '+wn)
    plt.imshow(matrix)
    ax.set_aspect('equal')
    cax = fig.add_axes([0.12, 0.1, 0.78, 0.8])
    cax.get_xaxis().set_visible(False)
    cax.get_yaxis().set_visible(False)
    cax.patch.set_alpha(0)
    cax.set_frame_on(False)
    plt.colorbar(orientation='vertical')
    plt.show()
    if save:
        name=name+'.png'
        fig.savefig(name, dpi = 600)
    plt.close()
    return   


def make_slice_fullmap(filename,mx,my,wavenumber): #Generates a graphical output for each wavenumber of the whole map
    if wavenumber <= 1162 and wavenumber >= 1084:
        entry=mt.trunc((wavenumber-1084)/2)
        good=True
    elif wavenumber <= 1800 and wavenumber >= 1184:
        entry=mt.trunc((wavenumber-1184+(1162-1084))/2)
        good=True
    else:
        print('Wavenumber out of range')
        good=False
    if good:
        namelist=pd.read_csv(filename, delimiter=';')
        print(namelist)
        name=str(namelist.name[0])
        mat = loadmat(name)
        wavenumbers = mat['wn']  # Read out for x Labels
        wavenumber_limit =wavenumbers.shape[0]
        print(wavenumber_limit)
        fullmap=np.ndarray(shape=(mx*480,my*480,1),dtype=np.float32)
        for i in namelist.index:
            name=str(namelist.name[i])
            print(name)
            mat = loadmat(name)
            deltaX = mat['dY']  # variable in mat file
            deltaY = mat['dX']  #
            mdata4  = mat['r']       
            for n in range(0,mdata4.shape[0],1):
                y_raw=(n)/int(deltaX[0]) #Caculation of the position on the map
                y=mt.trunc(y_raw)
                dy=np.int64(deltaY[0])
                ny=np.int64(y)
                x_raw=(n)-dy*ny
                x=int(x_raw)
                pos=mt.trunc(i/mx)
                py=int(pos*deltaY[0])
                px=int((i-pos*mx)*deltaX[0])
                fullmap[px+x,py+y,0]=mdata4[n,entry]    
        name=str(int(wavenumbers[entry]))+'_m_'+filename
        TwoDplotter(fullmap[:,:,0],name,str(int(wavenumbers[entry])))
        np.savetxt(name,fullmap[:,:,0],delimiter=';')           
    return

def make_slice(filename,mx,my,wavenumber): #Generates a graphical output for a destinct wavenumber for the whole map
    if wavenumber <= 1162 and wavenumber >= 1084:
        entry=mt.trunc((wavenumber-1084)/2)
        good=True
    elif wavenumber <= 1800 and wavenumber >= 1184:
        entry=mt.trunc((wavenumber-1184+(1162-1084))/2)
        good=True
    else:
        print('Wavenumber out of range')
        good=False
    if good:
        name=filename
        mat = loadmat(name)
        wavenumbers = mat['wn']  # Read out for x Labels
        wavenumber_limit =wavenumbers.shape[0]
        print(wavenumber_limit)
        fullmap=np.ndarray(shape=(mx*480,my*480,1),dtype=np.float32)
        deltaX = mat['dY']  # variable in mat file
        deltaY = mat['dX']  #
        mdata4  = mat['r']       
        for n in range(0,mdata4.shape[0],1):
            y_raw=(n)/int(deltaX[0])
            y=mt.trunc(y_raw)
            dy=np.int64(deltaY[0])
            ny=np.int64(y)
            x_raw=(n)-dy*ny
            x=int(x_raw)
            fullmap[x,y,0]=mdata4[n,entry]    
        #name=str(int(wavenumbers[entry]))+'_'+filename
        #sitkimage=data2image(fullmap)
        #write_image(sitkimage,name)
        name=str(int(wavenumbers[entry]))+'_m_'+filename
        TwoDplotter(fullmap[:,:,0],name,str(int(wavenumbers[entry])))
        name=str(int(wavenumbers[entry]))+'_m_'+filename+'.csv'
        np.savetxt(name,fullmap[:,:,0],delimiter=';')           
    return

#---#
# Main part:
#Examples how to start the script
    
#analyse_file('H18_21.csv',480,480,6,6,4.1875,Matlab=True,FTIR=False,QC=True,Matlabfilelist=False) #Typcial File with 6 times 6 fields
#analyse_file('highmag_h18_21.csv',480,480,20,20,1.365,Matlab=True,FTIR=False,QC=True,Matlabfilelist=False) #Typcial File vor HighMag with 20 times 20 fields
#analyse_file('RefEnv1_512.csv',512,512,2,2,11.03,Matlab=True,FTIR=True,QC=True,Matlabfilelist=False) #Typcial File for FTIR using the Matlab Macro for data export from OPUS with 2 times 2 fields
#evaluate_file('for_siMPLe_final_full_lADDH18_21_qaqc_short.csv','H18_21.csv',480,480,6,6,Matlab=True,SingleFile=False,FTIR=False) #An example for a file evaluation

#print('Finished')

#